//to do:
// Improve spawning - at the moment multiple asteroids/ship spawn at one point
// Improve enemy AI - make enemy change direction and fire the bullets when its near player etc
// Learn how to effectively tile bitmaps



#include <time.h>
#include <windows.h>
#include <stdio.h>

#include <iostream>		
#include <ctime>    // For time()
#include <cstdlib>  // For srand() and rand()
#include "main.h"
#include "resource.h"


using namespace std;

// --------------------------------------------------------------------
// Constants
// --------------------------------------------------------------------


#define BKGRD_WID 300 // Width of the background image in pixels
#define BKGRD_HGT 150 // Height of the background image in pixels
// Width and height of the game window
#define WIN_WID 800
#define WIN_HGT 600

// --------------------------------------------------------------------
// TYPES
// --------------------------------------------------------------------

typedef struct Mouse
{
	int x,y;
} Mouse;


// --------------------------------------------------------------------
// GLOBALS
// --------------------------------------------------------------------


Mouse MousePos;		//!< Mouse position


LRESULT CALLBACK WinProc(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam);


// --------------------------------------------------------------------
// System functions
// --------------------------------------------------------------------

//<! WinProc

LRESULT CALLBACK WinProc(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam)
{
	switch(message)
    {		
	case WM_COMMAND:

			if(LOWORD(wparam) == ID_OPTIONS_QUIT)
			{
				ShowCursor(TRUE);
				SendMessage(hwnd, WM_CLOSE, 0, 0);
			}
			break;

	case WM_CREATE:
		// Create the double buffer and load the bitmaps
		SystemInit(hwnd);
		GameInit();
		break;

	case WM_SIZE:
		// Buffers are resized when the height / width of the window changes
		ResizeBuffers(&gBuffer);
		break;

	case WM_KEYDOWN:
		keys[wparam]= true;
		break;

	case WM_KEYUP:
		keys[wparam]= false;
		break;

	case WM_MOUSEMOVE:
		MousePos.x = LOWORD (lparam);
		MousePos.y = HIWORD (lparam);
		break;	

	case WM_DESTROY:
		GameDeInit();
		SystemDeInit();
		break;

	default:break;
	}
		return(DefWindowProc(hwnd, message, wparam, lparam));

} // end of switch(message)

//<! WinMain

int WINAPI WinMain(HINSTANCE hinstance, HINSTANCE hprev, PSTR cmdline, int ishow)
{
	HWND hwnd = NULL;
	MSG msg = {0};
    WNDCLASSEX wndclassex = {0};
	char class_name[] = "Graphics Programming";
											
	// Initialisation of the important window properties			
    wndclassex.cbSize = sizeof(WNDCLASSEX);
    wndclassex.style = CS_HREDRAW | CS_VREDRAW;
    wndclassex.lpfnWndProc = WinProc;
    wndclassex.hInstance = hinstance;
	wndclassex.lpszClassName = class_name;
	wndclassex.hCursor = (HCURSOR)LoadImage(NULL, MAKEINTRESOURCE(IDC_ARROW), IMAGE_CURSOR,
											0, 0, LR_SHARED);
	wndclassex.lpszMenuName  = MAKEINTRESOURCE(IDR_MENU1);
    RegisterClassEx(&wndclassex);

	// Create the window
    hwnd = CreateWindowEx(WS_EX_APPWINDOW,
						  class_name,
						  "Graphics Programming - Simple Win32 Game",
						  WS_OVERLAPPED | WS_SYSMENU, // Window won't be resizable
						  CW_USEDEFAULT,
						  CW_USEDEFAULT, 
						  WIN_WID,
						  WIN_HGT,
						  NULL,
						  NULL,
						  hinstance,
						  NULL);

	// Error Check
	if(!hwnd)
		return EXIT_FAILURE;

	// Show and update window
    ShowWindow(hwnd, ishow);
    UpdateWindow(hwnd);
	/*HDC hdc = GetDC(hwnd);*/
	
	while(1)
	{
		// Checks for windows messages and take any actions if required
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			if(msg.message == WM_QUIT)break;
				
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else if(LockFrameRate(FRAME_RATE))
		{
			srand(time(0));  // Initialize random number generator.	
			SwapBackBuffer(&gBuffer, TRUE);		
			GameFrame();			
		}

	} // end of while(1)
	ShowCursor(TRUE);
	/*ReleaseDC(hwnd,hdc);*/
	UnregisterClass(class_name,hinstance); // Unregister the WNDCLASSEX
	return (int)msg.wParam;
}



